
  <!DOCTYPE html>
  <html>
    <head>
      <title>projects.ts</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/queries/projects.ts</td><td class="">99.00%</td><td class="">80%</td><td class="">200</td><td class="">198</td><td class="">2</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import {
  useMutation,
  useQueries,
  useQuery,
  useQueryClient,
  UseQueryResult
} from &#x27;react-query&#x27;;
import { Project, ProjectsApi } from &#x27;../api/projects&#x27;;
import { QUERIES } from &#x27;./queriesEnum&#x27;;
import { RequestWrapper } from &#x27;../api/requestWrapper&#x27;;
import { useMemo } from &#x27;react&#x27;;
import { CACHE_TIME } from &#x27;../cacheTime&#x27;;
import { MUTATIONS } from &#x27;./mutationsEnum&#x27;;
import { TargetRole } from &#x27;../pages/projects&#x27;;
import { FitParameter } from &#x27;../api/projectSettings&#x27;;

export const useProjects = ({ enabled }: { enabled?: boolean } = {}) =&gt; {
  const [projects, rendering] = useQueries([
    {
      queryKey: QUERIES.PROJECTS,
      queryFn: () =&gt; ProjectsApi.getUsersProjects(),
      cacheTime: CACHE_TIME,
      refetchInterval: CACHE_TIME,
      enabled
    },
    {
      queryKey: QUERIES.RENDERING,
      queryFn: () =&gt; ProjectsApi.rendering(),
      cacheTime: CACHE_TIME,
      refetchInterval: CACHE_TIME,
      enabled
    }
  ]) as [UseQueryResult&lt;RequestWrapper&lt;Project[]&gt;&gt;, UseQueryResult&lt;string[]&gt;];
  const isLoading = projects.isLoading || rendering.isLoading;

  return useMemo(
    () =&gt; ({
      isLoading,
      data: isLoading
        ? []
        : projects.data?.data.map((project) =&gt; ({
            ...project,
            isInRenderQueue: Boolean(rendering?.data?.includes(project.id))
          })) || []
    }),
    [isLoading, projects.data?.data, rendering.data]
  );
};

export const useProject = (projectId?: string | null) =&gt; {
  const { isLoading, data: projects } = useProjects({
    enabled: Boolean(projectId)
  });
  return {
    isLoading,
    project: useMemo(
      () =&gt;
        Boolean(projectId) &amp;&amp; !isLoading
          ? projects.find((project) =&gt; project.id === projectId)
          : null,
      [isLoading, projectId, projects]
    )
  };
};

export const useDeleteProject = ({
  onSuccess
}: { onSuccess?: () =&gt; void } = {}) =&gt; {
  const queryClient = useQueryClient();
  return useMutation(
    ({ projectId }: { projectId: string }) =&gt; {
      return ProjectsApi.delete(projectId);
    },
    {
      mutationKey: MUTATIONS.DELETE_PROJECT,
      onSuccess() {
        queryClient.refetchQueries(QUERIES.PROJECTS);
        if (onSuccess) {
          onSuccess();
        }
      }
    }
  );
};

export const useCreateProject = () =&gt;
  useMutation(
    ({
      initialFile,
      name,
      type
    }: {
      initialFile: File;
      name: string;
      type: &#x27;DIGITAL_TWIN&#x27; | &#x27;CLONE_SELECTION&#x27;;
    }) =&gt; ProjectsApi.create({ initialFile, name, type }),
    { mutationKey: MUTATIONS.CREATE_PROJECT_SETTINGS }
  );

export const useUpdateProject = () =&gt;
  useMutation(
    ({
      projectId,
      name,
      columnsMap,
      initialFile,
      newFitParameters,
      deleteFitParameters
    }: {
      projectId: string | number;
      initialFile?: File;
      columnsMap?: { [key in TargetRole]?: string };
      newFitParameters?: FitParameter[];
      deleteFitParameters?: string[];
      name?: string;
    }) =&gt;
      ProjectsApi.update(projectId, {
        name,
        columnsMap,
        initialFile,
        newFitParameters,
        deleteFitParameters
      }),
    {
      mutationKey: MUTATIONS.UPDATE_PROJECT
    }
  );

export const useFitProject = ({ projectId }: { projectId: string }) =&gt; {
  const queryClient = useQueryClient();
  return useMutation(() =&gt; ProjectsApi.fit(projectId), {
    mutationKey: [MUTATIONS.FIT_PROJECT, projectId],
    onSuccess() {
      queryClient.refetchQueries(QUERIES.PROJECTS);
      queryClient.refetchQueries(QUERIES.TASKS);
    }
  });
};

export const useInitialData = (projectId?: string | null) =&gt; {
  return useQuery(
    QUERIES.INITIAL_DATA,
    () =&gt; ProjectsApi.getInitialData(projectId as string),
    {
      enabled: Boolean(projectId)
    }
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/queries/projects.ts&quot;,&quot;line&quot;:17,&quot;character&quot;:32,&quot;text&quot;:&quot;useQueries([\n    {\n      queryKey: QUERIES.PROJECTS,\n      queryFn: () =&gt; ProjectsApi.getUsersProjects(),\n      cacheTime: CACHE_TIME,\n      refetchInterval: CACHE_TIME,\n      enabled\n    },\n    {\n      queryKey: QUERIES.RENDERING,\n      queryFn: () =&gt; ProjectsApi.rendering(),\n      cacheTime: CACHE_TIME,\n      refetchInterval: CACHE_TIME,\n      enabled\n    }\n  ]) as [UseQueryResult&lt;RequestWrapper&lt;Project[]&gt;&gt;, UseQueryResult&lt;string[]&gt;]&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/queries/projects.ts&quot;,&quot;line&quot;:142,&quot;character&quot;:37,&quot;text&quot;:&quot;projectId as string&quot;,&quot;kind&quot;:3}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  